﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace test002
{
    public partial class Form1 : Form
    {
        Button cellButton = null;
        Button cellLinkButton = null;

        public Form1()
        {
           InitializeComponent();
        }
        void cellButton_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Hello tag:" + ((Button)sender).Tag);
        }

        void cellLinkButton_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Hello2 tag:" + ((Button)sender).Tag);
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable myDataTable = new DataTable("MyDataTable");
            //Declares the Data Column and Data Row variables.
            DataColumn myDataColumn; DataRow myDataRow;
            //Creates a new Data Column, sets the Data Type and Column Name and adds to the Data Table. 
            myDataColumn = new DataColumn();
            myDataColumn.DataType = System.Type.GetType("System.Int32");
            myDataColumn.ColumnName = "id";
            myDataTable.Columns.Add(myDataColumn);
            //Creates a second column.
            myDataColumn = new DataColumn();
            myDataColumn.DataType = Type.GetType("System.String");
            myDataColumn.ColumnName = "item";
            myDataTable.Columns.Add(myDataColumn);
            //Creates new Data Row objects and adds to the Data Table. 
            for (int i = 0; i <= 10; i++)
            {
                myDataRow = myDataTable.NewRow();
                myDataRow["id"] = i; myDataRow["item"] = "item " + i.ToString();
                myDataTable.Rows.Add(myDataRow);
            } 

            this.gridDataBoundGrid1.DataSource = myDataTable;
            this.dataGridView1.DataSource = myDataTable;
         }

        private void textBox4_Enter(object sender, EventArgs e)
        {
            cellButton = new Button();
            cellButton.Size = new Size(((TextBox)sender).ClientSize.Height, ((TextBox)sender).ClientSize.Height + 2);  //OK   btn.Size = new Size(25, textBox1.ClientSize.Height + 2);
            cellButton.Location = new Point(((TextBox)sender).ClientSize.Width - cellButton.Width, -1);
            cellButton.Cursor = Cursors.Default;
            //  cellButton.Image = Properties.Resources.IKONA;
            // base.OnLoad(e);
            cellButton.Click += cellButton_Click;
            ((TextBox)sender).Controls.Add(cellButton); //  textBox1.Controls.Add(cellButton);
            cellButton.Tag = ((TextBox)sender).Text.ToString();

            // cellLinkButton link
            cellLinkButton = new Button();
            cellLinkButton.Size = new Size(((TextBox)sender).ClientSize.Height, ((TextBox)sender).ClientSize.Height / 3);  //OK   btn.Size = new Size(25, textBox1.ClientSize.Height + 2);
            cellLinkButton.Location = new Point(1, -1);
            cellLinkButton.Cursor = Cursors.PanEast;

            cellLinkButton.Click += cellLinkButton_Click;
            ((TextBox)sender).Controls.Add(cellLinkButton); //  textBox1.Controls.Add(cellButton);
        }

        private void textBox4_Validating(object sender, CancelEventArgs e)
        {
            ((TextBox)sender).Controls.Remove(cellButton);
            ((TextBox)sender).Controls.Remove(cellLinkButton);
        }

        private void gridAwareTextBox1_Enter(object sender, EventArgs e)
        {
            
           

        }

        private void gridAwareTextBox1_Validating(object sender, CancelEventArgs e)
        {
            

        }


        private void dataGridView1_CellEnter(object sender, DataGridViewCellEventArgs e)
        {

        }



        private void dataGridView1_CellValidating(object sender, DataGridViewCellValidatingEventArgs e)
        {
            ((DataGridView)sender).Controls.Remove(cellButton); //ok       dataGridView2.Controls.Remove(cellButton);  
        }

        private void dataGridView1_CellEnter(object sender, DataGridViewCellCancelEventArgs e)
        {
            Rectangle cell = ((DataGridView)sender).GetCellDisplayRectangle(e.ColumnIndex + 0, e.RowIndex + 0, false);// Rectangle cell = this.dataGridView2.GetCellDisplayRectangle(e.ColumnIndex + 0, e.RowIndex + 0, false);
            cellButton = new Button();
            cellButton.Tag = e.RowIndex;
            cellButton.Size = new Size(cell.Size.Height, cell.Size.Height); //d11   cellButton.Size = new Size(25, 9);
            // cellButton.Image = Properties.Resources.IKONA;
            cellButton.Click += new EventHandler(cellButton_Click);
            ((DataGridView)sender).Controls.Add(cellButton);//dataGridView2.Controls.Add(cellButton);
            cellButton.Location = new Point(cell.X + cell.Size.Width - cellButton.Width, cell.Y);
            cellButton.Tag = dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value.ToString();        
        }

      




    }
}
